package com.jiuqi.db;

import java.sql.SQLException;
import java.sql.DatabaseMetaData;
import com.jiuqi.db.impl.MySQLDBMetaData;
import com.jiuqi.db.impl.SybaseDBMetaData;
import com.jiuqi.db.impl.DB2DBMetaData;
import com.jiuqi.db.impl.OracleDBMetaData;
import com.jiuqi.db.impl.SQLServerDBMetaData;
import java.sql.Connection;

public class DBMetaDataFactory
{
    public static DBMetaData initDBMetaData(final Connection conn) throws SQLException {
        final DatabaseMetaData dbmd = conn.getMetaData();
        final String dbname = dbmd.getDatabaseProductName().toLowerCase();
        if (dbname.indexOf("sqlserver") != -1 || dbname.indexOf("sql server") != -1) {
            return (DBMetaData)new SQLServerDBMetaData(dbmd);
        }
        if (dbname.indexOf("oracle") != -1) {
            return (DBMetaData)new OracleDBMetaData(dbmd);
        }
        if (dbname.indexOf("db2") != -1) {
            return (DBMetaData)new DB2DBMetaData(dbmd);
        }
        if (dbname.indexOf("adaptive") != -1 || dbname.indexOf("sybase") != -1) {
            return (DBMetaData)new SybaseDBMetaData(dbmd);
        }
        if (dbname.indexOf("mysql") != -1) {
            return (DBMetaData)new MySQLDBMetaData(dbmd);
        }
        return null;
    }
}
